<script type="text/html" data-help-name="dim-xml-params-client">
  <style>
    tr:nth-child(even) {background-color: #f8f8f8;}
    tr:nth-child(odd) {background-color: #e8e8e8;}
  </style>
  <p>
    A DIM-XML Client node to subscribe a Parameters service on a DIM Service
    Provider (DIS). This node is used to get/set parameters.
  </p>
  <h3>Inputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object | array</span></dt>
    <dd>The command to update the parameters list.</dd>
  </dl>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">array</span></dt>
    <dd>The service value received.</dd>
    <dt class="optional">
      timestamp<span class="property-type">number</span>
    </dt>
    <dd>The value's UNIX timestamp in millisecs.</dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node must be configured with the name of the service to be subscribed
    to and a connection to the the DIM Name Server (DNS) hosting that service.
    For the latter, it is possible to either create a new DNS Server connection
    by clicking on the pencil icon or use an existing one shared between
    several DIM-XML nodes.
  </p>
  <p>
    The node can retrieve the list of the <i>Parameters</i> services registered
    on the DNS Server set-up.
  </p>
  <p>
    The command used for update the list of parameters can be a single object
    or an array of objects, but all MUST have the following properties:
    <ul>
      <li>
        <code>index</code>, the integer identifying the parameter to be updated;
      </li>
      <li>
        <code>type</code>, the integer specifying the type of the parameter
        (see the table below);
      </li>
      <li>
        <code>value</code>, the value to set;
      </li>
    </ul>
    It is important that <code>type</code> in the command corresponds to that
    of the parameter to be modified.<br>
    If parameter(s) are successfully updated, the node will provide the new
    parameter list as output according to the mode of service value fetching
    (explained later).<br>
    Instead, if the update fails, the output will contain an empty array in
    <code>msg.payload</code>, the error code in <code>msg.error</code>, the
    error message in <code>msg.message</code> and <code>msg.status</code>
    set to <b>3</b>.
    Examples of commands are:
    <ul>
      <li>
        to update a single parameter:
        <pre>{ index: 12, value: 600, type: 11 }</pre>
      </li>
      <li>
        to update more parameters:
        <pre>[ { index: 7, value: false, type: 9 }, { index: 4, value: 3.21, type: 8 } ]</pre>
      </li>
      <li>
        to update a <i>nested</i> parameter:
        <pre>{ index: 4, value: [ { index: 1, value: 92, type: 6 } ] }</pre>
      </li>
    </ul>
  </p>
  <p>
    Regarding the received service value, it consists of an array of
    <i>parameters</i>, saved in the output <code>payload</code> property.
    A parameter is an object with these properties:
    <ul>
      <li>
        <code>name</code>, an optional string that describes the parameter;
      </li>
      <li>
        <code>index</code>, an integer to uniquely indentify the parameter
        within the set of parameters;
      </li>
      <li>
        <code>unit</code>, an optional string describing the value's unit;
      </li>
      <li>
        <code>type</code>, an integer matching one of the following:
        <table style="outline-width:#888 solid thin;text-align:left">
          <tr style="background-color: #e6e6e6;">
            <th width="50px">Type</th><th width="60px">Value</th>
          </tr>
          <tr><td>1</td><td>int32</td></tr>
          <tr><td>2</td><td>double</td></tr>
          <tr><td>3</td><td>string</td></tr>
          <tr><td>4</td><td>int64</td></tr>
          <tr><td>5</td><td>enum</td></tr>
          <tr><td>6</td><td>int8</td></tr>
          <tr><td>7</td><td>int16</td></tr>
          <tr><td>8</td><td>float</td></tr>
          <tr><td>9</td><td>bool</td></tr>
          <tr><td>11</td><td>uint32</td></tr>
          <tr><td>14</td><td>uint64</td></tr>
          <tr><td>16</td><td>uint8</td></tr>
          <tr><td>17</td><td>uint16</td></tr>
        </table>
      </li>
      <li>
        <code>value</code>, the parameter value.
      </li>
    </ul>
    Furthermore, <i>enum</i> parameter have two additional properties:
    <ul>
      <li>
        <code>enum</code>, the list of all possible values that can be
        assigned to the parameter;
      </li>
      <li>
        <code>valueName</code>, the name associated with the selected value.
      </li>
    </ul>
    If the parameter have no type, it is a <i>nested</i> parameter, that is the
    <code>value</code> property can contain sub-parameters such as those
    described above.
  </p>
  <p>
    By default, the node is configured to retrieve the service value manually,
    by clicking on its button within the editor. It can also be set to monitor
    a value, get the value with a given schedule or both. In particular, with
    the option:
    <ul>
      <li><b>Monitored</b>, if enabled, the node receives a service value when
        updated server side.
      <li><b>Scheduled</b>, if enabled, the node receives a service value at a
        regular time intervals defined by the <i>Every</i> field. The time
        interval is equal to 1000 millisecs by default.
    </ul>
  </p>
  <p>
    The first service value is received upon subscription, which is the current
    service value or a <i>null</i> one if it is not set.
  </p>
  <p>
    It is also possible to request service values with additional timestamp
    information by selecting the <b>Stamped</b> option. Thus, the value's
    timestamp is saved in the <code>msg.timestamp</code> property.
  </p>
</script>
